Asterisk.org: Developer Documentation (28 Oct 2009)

Wed Oct 28 15:48:21 2009

## Asterisk developer's documentation

# astmm.h File Reference

Asterisk memory usage debugging. More...

`#include <sys/types.h>`
`#include <stdlib.h>`
`#include <string.h>`
`#include <stdio.h>`

Include dependency graph for astmm.h:

Go to the source code of this file.

## Defines

#define | __AST_DEBUG_MALLOC
#define | calloc(a, b) __ast_calloc(a,b,__FILE__, __LINE__, __PRETTY_FUNCTION__)
#define | free(a) __ast_free(a,__FILE__, __LINE__, __PRETTY_FUNCTION__)
#define | malloc(a) __ast_malloc(a,__FILE__, __LINE__, __PRETTY_FUNCTION__)
#define | realloc(a, b) __ast_realloc(a,b,__FILE__, __LINE__, __PRETTY_FUNCTION__)
#define | strdup(a) __ast_strdup(a,__FILE__, __LINE__, __PRETTY_FUNCTION__)
#define | strndup(a, b) __ast_strndup(a,b,__FILE__, __LINE__, __PRETTY_FUNCTION__)
#define | vasprintf(a, b, c) __ast_vasprintf(a,b,c,__FILE__, __LINE__, __PRETTY_FUNCTION__)

## Functions

void * | __ast_calloc (size_t nmemb, size_t size, const char *file, int lineno, const char *func)
void | __ast_free (void *ptr, const char *file, int lineno, const char *func)
void * | __ast_malloc (size_t size, const char *file, int lineno, const char *func)
void | __ast_mm_init (void)
void * | __ast_realloc (void *ptr, size_t size, const char *file, int lineno, const char *func)
char * | __ast_strdup (const char *s, const char *file, int lineno, const char *func)
char * | __ast_strndup (const char *s, size_t n, const char *file, int lineno, const char *func)
int | __ast_vasprintf (char **strp, const char *format, va_list ap, const char *file, int lineno, const char *func)

## Detailed Description

Asterisk memory usage debugging.

Definition in file astmm.h.

## Define Documentation

#define __AST_DEBUG_MALLOC

Definition at line 27 of file astmm.h.

#define calloc | ( | a,
|  | b |  | ) | __ast_calloc(a,b,__FILE__, __LINE__, __PRETTY_FUNCTION__)

Definition at line 55 of file astmm.h.

Referenced by __ao2_link(), __ast_device_state_changed_literal(), _parse(), add_sip_domain(), ao2_alloc(), ast_app_group_set_channel(), ast_channel_spy_add(), ast_channel_start_silence_generator(), ast_devstate_add(), ast_dnsmgr_get(), ast_frdup(), ast_merge_contexts_and_delete(), ast_netsock_list_alloc(), ast_register_file_version(), ast_var_assign(), ast_verbose(), build_conf(), conf_run(), do_proxy_auth(), gen_alloc(), get_robin_position(), getSearchPath(), launch_monitor_thread(), load_module(), make_entry(), misdn_cfg_init(), mkif(), new_odbc_obj(), register_translator(), sip_alloc(), sip_request_call(), vm_execmain(), yyparse(), zap_new_alawtog723(), zap_new_alawtog729(), zap_new_g723toalaw(), zap_new_g723toulaw(), zap_new_g729toalaw(), zap_new_g729toulaw(), zap_new_ulawtog723(), and zap_new_ulawtog729().

#define free | ( | a |  | ) | __ast_free(a,__FILE__, __LINE__, __PRETTY_FUNCTION__)

Definition at line 61 of file astmm.h.

Referenced by __ast_cli_generator(), __ast_context_destroy(), __ast_pbx_run(), __load_resource(), __login_exec(), __oh323_destroy(), __sip_ack(), __sip_destroy(), __unload_module(), _free_general_cfg(), _free_msn_list(), _free_port_cfg(), acf_curl_exec(), adpcm_destroy(), adsi_prog(), agent_cleanup(), agent_hangup(), agi_debug_cli(), alarmreceiver_exec(), alaw_destroy(), ao2_callback(), ao2_ref(), aPGSQL_clear(), aPGSQL_connect(), aPGSQL_disconnect(), aPGSQL_fetch(), aPGSQL_query(), aPGSQL_reset(), app_exec(), arg_free(), ast_add_extension2(), ast_ael_compile(), ast_app_group_discard(), ast_app_group_set_channel(), ast_append_ha(), ast_autoservice_start(), ast_autoservice_stop(), ast_bridge_call(), ast_bridge_call_thread(), ast_category_destroy(), ast_cdr_free(), ast_cdr_unregister(), ast_channel_alloc(), ast_channel_free(), ast_channel_start_silence_generator(), ast_channel_stop_silence_generator(), ast_channel_unregister(), ast_cli(), ast_cli_command(), ast_cli_display_match_list(), ast_cli_generatornummatches(), ast_closestream(), ast_config_destroy(), ast_context_add_include2(), ast_context_add_switch2(), ast_context_remove_extension2(), ast_context_remove_ignorepat2(), ast_context_remove_include2(), ast_context_remove_switch2(), ast_db_freetree(), ast_devstate_del(), ast_dnsmgr_release(), ast_dsp_free(), ast_enum_init(), ast_expr(), ast_extension_state_del(), ast_filehelper(), ast_format_unregister(), ast_free_ha(), ast_frfree(), ast_frisolate(), ast_get_enum(), ast_io_remove(), ast_manager_unregister(), ast_merge_contexts_and_delete(), ast_moh_free_class(), ast_monitor_change_fname(), ast_monitor_start(), ast_monitor_stop(), ast_netsock_bindaddr(), ast_netsock_destroy(), ast_park_call(), ast_pbx_outgoing_app(), ast_pbx_outgoing_exten(), ast_pbx_run_app(), ast_playtones_start(), ast_read_textfile(), ast_readfile(), ast_recvchar(), ast_register_indication(), ast_remove_hint(), ast_rtcp_new(), ast_rtp_destroy(), ast_rtp_new_with_bindaddr(), ast_set_callerid(), ast_smoother_free(), ast_translator_free_path(), ast_unload_resource(), ast_unregister_application(), ast_unregister_feature(), ast_unregister_features(), ast_unregister_file_version(), ast_unregister_indication(), ast_unregister_verbose(), ast_var_delete(), ast_variables_destroy(), ast_verbose(), ast_writefile(), ast_yyfree(), async_wait(), attempt_reconnect(), au_close(), au_open(), au_rewrite(), build_conf(), build_device(), build_gateway(), build_peer(), build_user(), callerid_feed(), callerid_free(), callerid_write(), changethread(), cleanup_call_details(), clear_and_free_interfaces(), clear_config_maps(), clear_realm_authentication(), clear_sip_domains(), cli_complete(), close_logger(), compile_script(), complete_context_add_ignorepat(), complete_context_add_include(), complete_context_dont_include(), complete_context_remove_extension(), complete_context_remove_ignorepat(), conf_free(), conf_run(), config_load(), console_dial(), console_transfer(), crypto_load(), curl_exec(), del_identifier(), delete_aliases(), delete_devices(), delete_sub(), delete_users(), destroy_endpoint(), destroy_exten(), destroy_firmware(), destroy_gateway(), destroy_map(), destroy_odbc_obj(), destroy_packet(), destroy_packets(), destroy_peer(), destroy_permissions(), destroy_queue(), destroy_session(), destroy_trans(), destroy_user(), destroy_zt_pvt(), dial_exec_full(), dlcompat_cleanup(), dlerrorfree(), dlsym(), dlsymIntern(), do_batch_backend_process(), do_devstate_changes(), do_directory(), do_monitor(), do_parking_thread(), dp_lookup_thread(), drop_translator(), dump_cmd_queues(), dump_queue(), dundi_answer_entity(), dundi_answer_query(), dundi_flush(), dundi_lookup_thread(), dundi_precache_thread(), dundi_prop_precache(), dundi_query_thread(), dundi_send(), external_rtp_create(), fast_originate(), features_hangup(), festival_exec(), fillin_free(), find_and_retrans(), find_cache(), find_queue_by_name_rt(), find_user_realtime(), fix_complete_args(), free_cid(), free_context(), free_members(), free_old_route(), free_outgoing(), free_robin_list_r(), free_session(), free_user(), free_value(), free_zone(), function_ilink(), g723_close(), g723_destroy(), g723_open(), g723_rewrite(), g726_16_open(), g726_16_rewrite(), g726_24_open(), g726_24_rewrite(), g726_32_open(), g726_32_rewrite(), g726_40_open(), g726_40_rewrite(), g726_close(), g726_destroy(), g729_close(), g729_open(), g729_rewrite(), gen_release(), get_callerid_ast(), getSearchPath(), gsm_close(), gsm_destroy_stuff(), gsm_new(), gsm_open(), gsm_rewrite(), h263_close(), h263_open(), h263_rewrite(), handle_add_indication(), handle_commandcomplete(), handle_commandmatchesarray(), handle_context_add_extension(), handle_init_event(), handle_message(), handle_recvtext(), handle_response(), handle_showuptime(), hangupcalls(), hanguptree(), iax2_setoption(), iax_frame_free(), iax_park(), iax_park_thread(), iax_provision_reload(), ilbc_close(), ilbc_destroy_stuff(), ilbc_open(), ilbc_rewrite(), ind_load_module(), init_logger_chain(), io_context_create(), io_context_destroy(), jb_destroy(), launch_monitor_thread(), launch_page(), linear_alloc(), linear_release(), lintospeex_destroy(), lintospeex_new(), load_config(), load_module(), load_moh_classes(), loadModule(), local_alloc(), local_ast_moh_cleanup(), local_hangup(), local_queue_frame(), lpc10_dec_new(), lpc10_destroy(), lpc10_enc_new(), macro_exec(), make_logchannel(), mgcpsock_read(), milliwatt_release(), misdn_cfg_destroy(), misdn_hangup(), misdn_jb_destroy(), mixmonitor_thread(), mkif(), modem_setup(), moh_register(), moh_release(), mohalloc(), my_unload_module(), nbs_alloc(), nbs_destroy(), new_odbc_obj(), odbc_unload_module(), ogg_vorbis_close(), ogg_vorbis_open(), ogg_vorbis_rewrite(), oh323_alloc(), oh323_answer(), oh323_digit(), oh323_hangup(), oh323_indicate(), page_thread(), park_exec(), parkandannounce_exec(), pbx_destroy(), pbx_load_module(), pcm_close(), pcm_open(), pcm_rewrite(), playtones_release(), process_message(), process_precache(), prune_peers(), read_agent_config(), readfile_exec(), register_translator(), release_chan(), reload_module(), reload_queues(), remove_from_interfaces(), remove_from_queue(), retrans_pkt(), ring_entry(), rpt(), rpt_call(), rpt_exec(), rpt_tele_thread(), sched_context_destroy(), sched_release(), send_callerid(), send_request(), setrdnis_exec(), sip_alloc(), sip_destroy_peer(), sip_destroy_user(), sip_park(), sip_park_thread(), sip_registry_destroy(), skinny_req_parse(), slinear_close(), slinear_open(), slinear_rewrite(), speextolin_destroy(), speextolin_new(), spy_cleanup(), sqlite_log(), ss_thread(), statechange_queue(), store_config(), store_mixer(), tdd_feed(), tdd_free(), tds_log(), tds_unload_module(), timing_read(), to_integer(), tonepair_release(), transmit_response_using_temp(), ulaw_destroy(), unload_module(), unregister_translators(), vm_execmain(), vm_forwardoptions(), vox_close(), vox_open(), vox_rewrite(), vpb_request(), wait_for_answer(), wav_close(), wav_open(), wav_rewrite(), yyparse(), zt_call(), zt_callwait(), zt_handle_dtmfup(), zt_handle_event(), zt_hangup(), and zt_sendtext().

#define malloc | ( | a |  | ) | __ast_malloc(a,__FILE__, __LINE__, __PRETTY_FUNCTION__)

Definition at line 58 of file astmm.h.

Referenced by __ast_pbx_run(), __build_step(), __grab_token(), __load_resource(), __sip_reliable_xmit(), _parse(), accept_thread(), action_originate(), add_agent(), add_channel(), add_identifier(), add_realm_authentication(), add_to_interfaces(), adpcmtolin_new(), alawtolin_new(), alawtoulaw_new(), alloc_queue(), allocStatus(), anti_injection(), aPGSQL_clear(), aPGSQL_connect(), aPGSQL_disconnect(), aPGSQL_fetch(), aPGSQL_query(), aPGSQL_reset(), append_event(), append_history(), append_mailbox(), append_mapping(), append_permission(), append_sub(), arg_parse(), ast_add_extension2(), ast_add_hint(), ast_ael_compile(), ast_append_ha(), ast_autoservice_start(), ast_category_new(), ast_cdr_alloc(), ast_cdr_detach(), ast_cdr_register(), ast_channel_alloc(), ast_channel_register(), ast_cli_completion_matches(), ast_config_new(), ast_context_add_ignorepat2(), ast_context_add_include2(), ast_context_add_switch2(), ast_context_create(), ast_db_gettree(), ast_dsp_new(), ast_duplicate_ha(), ast_extension_state_add(), ast_format_register(), ast_frame_header_new(), ast_frisolate(), ast_io_add(), ast_linear_stream(), ast_loader_register(), ast_manager_register2(), ast_monitor_start(), ast_netsock_bindaddr(), ast_park_call(), ast_pbx_outgoing_app(), ast_pbx_outgoing_exten(), ast_read_textfile(), ast_register_application(), ast_register_atexit(), ast_register_indication(), ast_register_verbose(), ast_rtcp_new(), ast_rtp_new_with_bindaddr(), ast_say_number_full_pl(), ast_smoother_new(), ast_translator_build_path(), ast_variable_new(), ast_yyalloc(), au_open(), au_rewrite(), build_alias(), build_context(), build_device(), build_filename(), build_gateway(), build_mapping(), build_peer(), build_route(), build_user(), builtin_atxfer(), callerid_feed(), callerid_new(), chandup(), cli_complete(), compile_script(), complete_add_queue_member(), complete_context_remove_extension(), convert(), create_queue_member(), create_transaction(), destroy_trans(), dial_exec_full(), dlsym(), dlsymIntern(), do_monitor(), dolock(), dundi_answer_entity(), dundi_answer_query(), dundi_prop_precache(), dundi_send(), dyld_error_str(), enum_newtoplev(), external_rtp_create(), features_alloc(), find_cache(), find_tpeer(), find_user(), find_user_realtime(), function_ilink(), g723_open(), g723_rewrite(), g723tolin_new(), g726_16_open(), g726_16_rewrite(), g726_24_open(), g726_24_rewrite(), g726_32_open(), g726_32_rewrite(), g726_40_open(), g726_40_rewrite(), g726tolin_new(), g729_open(), g729_rewrite(), gmtsub(), gsm_new(), gsm_open(), gsm_rewrite(), h263_open(), h263_rewrite(), handle_add_indication(), handle_commandmatchesarray(), iax2_register(), iax2_setoption(), iax_frame_new(), iax_park(), iax_process_template(), ilbc_open(), ilbc_rewrite(), ilbctolin_new(), ind_load_module(), init_batch(), init_chan_list(), init_logger_chain(), io_context_create(), jb_new(), launch_page(), lintoadpcm_new(), lintoalaw_new(), lintog723_new(), lintog726_new(), lintoilbc_new(), lintospeex_new(), lintoulaw_new(), load_config(), load_module(), local_alloc(), local_call(), lpc10_dec_new(), lpc10_enc_new(), make_integer(), make_logchannel(), make_str(), mgcp_postrequest(), milliwatt_alloc(), misdn_jb_init(), mkbrd(), mkif(), mkintf(), moh_class_malloc(), moh_files_alloc(), mohalloc(), myrealloc(), nbs_alloc(), new_odbc_obj(), ogg_vorbis_open(), ogg_vorbis_rewrite(), oh323_alloc(), osp_build(), P(), param_parse(), parkandannounce_exec(), pcm_open(), pcm_rewrite(), playtones_alloc(), queue_put(), receive_ademco_contact_id(), req_alloc(), reschedule_precache(), rpt_exec(), rpt_tele_thread(), rpt_telemetry(), scan_service(), sched_alloc(), sched_context_create(), searchList(), send_cwcidspill(), send_request(), sip_park(), sip_register(), skinny_req_parse(), slinear_open(), slinear_rewrite(), socket_receive_file_to_buff(), spawn_dp_lookup(), speextolin_new(), start_monitor_action(), statechange_queue(), store_config(), strndup(), tdd_feed(), tdd_new(), temp_peer(), to_string(), tonepair_alloc(), transmit_response(), try_calling(), try_firmware(), try_load_key(), ulawtoalaw_new(), ulawtolin_new(), vasprintf(), vox_open(), vox_rewrite(), wait_for_answer(), wav_open(), wav_rewrite(), zt_call(), zt_callwait(), and zt_sendtext().

#define realloc | ( | a,
|  | b |  | ) | __ast_realloc(a,b,__FILE__, __LINE__, __PRETTY_FUNCTION__)

Definition at line 64 of file astmm.h.

Referenced by ast_ael_compile(), ast_cli_completion_matches(), ast_el_strtoarr(), ast_playtones_start(), ast_yyrealloc(), cli_complete(), enum_callback(), handle_commandmatchesarray(), iax2_trunk_queue(), ind_load_module(), io_grow(), myrealloc(), and socket_receive_file_to_buff().

#define strdup | ( | a |  | ) | __ast_strdup(a,__FILE__, __LINE__, __PRETTY_FUNCTION__)

Definition at line 67 of file astmm.h.

Referenced by __ast_cli_generator(), __build_step(), __grab_token(), __oh323_new(), add_channel(), aopen_identify(), append_sub(), ast_el_strtoarr(), ast_ext_ctx(), ast_frisolate(), ast_iax2_new(), ast_modem_new(), ast_module_helper(), ast_monitor_change_fname(), ast_monitor_start(), ast_park_call(), ast_readfile(), ast_register_indication(), ast_set_callerid(), ast_verbose(), ast_writefile(), attempt_reconnect(), autoanswer_complete(), bestdata_handle_escape(), bestdata_identify(), build_rpid(), callerid_write(), complete_add_queue_member(), complete_agent_logoff_cmd(), complete_ch_helper(), complete_confcmd(), complete_context_add_extension(), complete_context_add_ignorepat(), complete_context_add_include(), complete_context_dont_include(), complete_context_remove_extension(), complete_context_remove_ignorepat(), complete_debug_port(), complete_fn(), complete_iax2_show_peer(), complete_peer_helper(), complete_queue(), complete_remove_queue_member(), complete_show_application(), complete_show_applications(), complete_show_channels(), complete_show_dialplan_context(), complete_show_function(), complete_show_mancmd(), complete_show_version_files(), complete_show_voicemail_users(), complete_sip_peer(), complete_sip_user(), complete_sipch(), complete_sipnotify(), dial_exec_full(), do_directory(), do_parking_thread(), enum_callback(), features_call(), fillin_process(), fix_complete_args(), format_uptimestr(), function_ilink(), get_callerid_ast(), handle_context_add_extension(), handle_link_data(), handle_macro(), i4l_identify(), iax_prov_complete_template(), ind_load_module(), load_config(), load_module(), local_call(), macro_exec(), make_str(), mgcp_new(), misdn_new(), odbc_load_module(), oh323_answer(), oh323_digit(), oh323_hangup(), oh323_indicate(), parse_args(), pbx_load_module(), phone_new(), process_my_load_module(), read_config(), register_peer_exten(), reload_module(), ring_entry(), rpt_call(), send_link_dtmf(), setrdnis_exec(), sip_new(), skinny_new(), spawn_dp_lookup(), store_config(), store_mixer(), tds_load_module(), vpb_new(), vpb_request(), wait_for_answer(), zt_handle_event(), and zt_new().

#define strndup | ( | a,
|  | b |  | ) | __ast_strndup(a,b,__FILE__, __LINE__, __PRETTY_FUNCTION__)

Definition at line 70 of file astmm.h.

Referenced by ast_recvtext(), and get_robin_position().

#define vasprintf | ( | a,
|  | b,
|  | c |  | ) | __ast_vasprintf(a,b,c,__FILE__, __LINE__, __PRETTY_FUNCTION__)

Definition at line 73 of file astmm.h.

Referenced by agi_debug_cli(), and ast_cli().

## Function Documentation

void* __ast_calloc | ( | size_t | nmemb,
|  | size_t | size,
|  | const char * | file,
|  | int | lineno,
|  | const char * | func |
| ) |  |  |

void __ast_free | ( | void * | ptr,
|  | const char * | file,
|  | int | lineno,
|  | const char * | func |
| ) |  |  |

void* __ast_malloc | ( | size_t | size,
|  | const char * | file,
|  | int | lineno,
|  | const char * | func |
| ) |  |  |

void __ast_mm_init | ( | void |  | ) |

Referenced by main().

void* __ast_realloc | ( | void * | ptr,
|  | size_t | size,
|  | const char * | file,
|  | int | lineno,
|  | const char * | func |
| ) |  |  |

char* __ast_strdup | ( | const char * | s,
|  | const char * | file,
|  | int | lineno,
|  | const char * | func |
| ) |  |  |

char* __ast_strndup | ( | const char * | s,
|  | size_t | n,
|  | const char * | file,
|  | int | lineno,
|  | const char * | func |
| ) |  |  |

int __ast_vasprintf | ( | char ** | strp,
|  | const char * | format,
|  | va_list | ap,
|  | const char * | file,
|  | int | lineno,
|  | const char * | func |
| ) |  |  |